<?php

namespace App\Http\Middleware\Board;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;
use App\Services\BoardService;

class BoardAccess
{
    public function handle(Request $request, Closure $next)
    {
        $code = $request->route('code');

        // 게시판 코드 확인
        if (!$code) {
            abort(404);
        }

        $boardService = new BoardService();

        // 게시판 정보 조회
        $board = $boardService->find($code);

        // 게시판 존재 유무
        if (!$board->exists) {
            return alert('존재하지 않는 게시판입니다.', DIRECTORY_SEPARATOR);
        }

        // 게시판 사용 여부
        if ($board->is_display == 0) {
            return alert('더 이상 사용하지 않는 게시판입니다.', DIRECTORY_SEPARATOR);
        }

        $boardMeta = $boardService->meta($board->id);

        // 목록 권한 확인
        $response = Gate::inspect('viewAny', ['App\Models\Board', $boardMeta]);
        if($response->denied()) {
            if($response->code() == 401) {
                return loginCheck(DIRECTORY_SEPARATOR);
            }else{
                return alert($response->message(), DIRECTORY_SEPARATOR);
            }
        }

        $request->merge([
            'board' => $board,
            'boardMeta' => $boardMeta
        ]);

        return $next($request);
    }
}
